#!/usr/bin/python3

import asyncio
import random


async def laburo(idx):
    delay = random.random()
    print(f"Trabajo! {idx=} {delay=:.3f}")
    await asyncio.sleep(delay)
    return idx, delay


def mostrar(task):
    idx, delay = task.result()
    print(f"Listo: {idx=} {delay=:.3f}")


async def trabajo_extra():
    await asyncio.sleep(0.5)


async def main():
    print("Comienzo")

    tareas = []
    for idx in range(5):
        tarea = asyncio.create_task(laburo(idx))
        tarea.add_done_callback(mostrar)
        tareas.append(tarea)
    print("Todas las tareas creadas")

    await trabajo_extra()
    print("Terminado trabajo extra")

    await asyncio.gather(*tareas)
    print("Fin")


asyncio.run(main())
